#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_FishChuBaoCFG.h"
std::auto_ptr<Fish_FishChuBaoCFG> Fish_FishChuBaoCFG::msSingleton(nullptr);

int Fish_FishChuBaoCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_FishChuBaoCFGData* Fish_FishChuBaoCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_FishChuBaoCFGData>& Fish_FishChuBaoCFG::GetMapData()
{
	return mMapData;
}

void Fish_FishChuBaoCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_FishChuBaoCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_FishChuBaoCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mFishId = element->IntAttribute("FishId");
		data.mTurretMin = element->IntAttribute("TurretMin");
		data.mTurretMax = element->IntAttribute("TurretMax");
		data.mScore = element->IntAttribute("Score");
		data.mWeight = element->IntAttribute("Weight");
		data.mGold = element->IntAttribute("Gold");
		{
			const char* GivenReward = element->Attribute("GivenReward");
			std::vector<std::string> vecGivenReward;
			boost::split(vecGivenReward, GivenReward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecGivenReward.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecGivenReward[i].c_str(), &temp))
				{
					data.mGivenReward.push_back(temp);
				}
			}
		}
		data.mGearName = element->Attribute("GearName");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_FishChuBaoCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_FishChuBaoCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_FishChuBaoCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_FishChuBaoCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_FishChuBaoCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "FishId", data.mFishId);
		LuaCfgHelper::readInt(L, "TurretMin", data.mTurretMin);
		LuaCfgHelper::readInt(L, "TurretMax", data.mTurretMax);
		LuaCfgHelper::readInt(L, "Score", data.mScore);
		LuaCfgHelper::readInt(L, "Weight", data.mWeight);
		LuaCfgHelper::readInt(L, "Gold", data.mGold);
		LuaCfgHelper::readVectorInt(L, "GivenReward", data.mGivenReward);
		LuaCfgHelper::readString(L, "GearName", data.mGearName);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_FishChuBaoCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_FishChuBaoCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_FishChuBaoCFG* Fish_FishChuBaoCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_FishChuBaoCFG());
	}
	return msSingleton.get();
}

void Fish_FishChuBaoCFG::Release()
{
	msSingleton.reset(nullptr);
}
